14_module_d/source/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'Backend\AuthController@getHome');


Route::get('/login', 'Backend\AuthController@loginForm')->name('login');
Route::post('/login', 'Backend\AuthController@actionLogin')->name('login');

Route::middleware('auth')->group(function () {
    Route::get('/logout', 'Backend\AuthController@actionLogout')->name('logout');
    Route::prefix('campaign')->name('campaign.')->group(function () {
        Route::get('/', 'Backend\CampaignController@managers')->name('manager');
        Route::get('/create', 'Backend\CampaignController@createForm')->name('create');
        Route::post('/create', 'Backend\CampaignController@actionCreate')->name('create');
        Route::get('/{id}-{slug}', 'Backend\CampaignController@detailCampaign')->name('detail');
        Route::get('/{id}-{slug}/edit', 'Backend\CampaignController@editCampaign')->name('edit');
        Route::post('/{id}-{slug}/edit', 'Backend\CampaignController@actionEdit')->name('edit');
        Route::get('/{id}-{slug}/create-ticket', 'Backend\TicketController@createForm')->name('create_ticket');
        Route::post('/{id}-{slug}/create-ticket', 'Backend\TicketController@actionCreate')->name('create_ticket');
        Route::get('/{id}-{slug}/create-area', 'Backend\AreaController@createForm')->name('create_area');
        Route::post('/{id}-{slug}/create-area', 'Backend\AreaController@actionCreate')->name('create_area');
        Route::get('/{id}-{slug}/create-place', 'Backend\PlaceController@createForm')->name('create_place');
        Route::post('/{id}-{slug}/create-place', 'Backend\PlaceController@actionCreate')->name('create_place');
        Route::get('/{id}-{slug}/report', 'Backend\CampaignController@reportChart')->name('report');


        Route::get('/{id}-{slug}/create-session', 'Backend\SessionController@createForm')->name('create_session');
        Route::post('/{id}-{slug}/create-session', 'Backend\SessionController@actionCreate')->name('create_session');


        Route::get('/{id}-{slug}/update-session/{id_session}', 'Backend\SessionController@updateForm')->name('update_session');
        Route::post('/{id}-{slug}/update-session/{id_session}', 'Backend\SessionController@actionUpdate')->name('update_session');
    });
});

14_module_d/source/app/Models/Campaign.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Campaign extends Model
{
    public $timestamps = false;

    public $hidden = ['organizer_id'];

    // public $dates = ['date'];

    public $fillable = ['name', 'slug', 'date'];

    public function getDateAttribute( $value ) {
        return (\Carbon\Carbon::parse($value))->format('Y-m-d');
    }

    public function registrations()
    {
        return $this->hasManyThrough(Registration::class, CampaignTicket::class, 'campaign_id' , 'ticket_id');
    }

    public function tickets()
    {
        return $this->hasMany(CampaignTicket::class);
    }

    public function areas()
    {
        return $this->hasMany(Area::class);
    }

    public function places()
    {
        return $this->hasManyThrough(Place::class, Area::class);
    }

    public function sessions()
    {
        return Session::whereIn('place_id', $this->places->pluck('id'))->get();
    }

    public function organizer()
    {
        return $this->belongsTo(Organizer::class);
    }
}

14_module_d/source/app/Models/CampaignTicket.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class CampaignTicket extends Model
{
    public $timestamps = false;

    protected $appends = ['description', 'available'];

    public $hidden = ['campaign_id', 'special_validity'];

    public function getSpecialValidityAttribute($value)
    {
        $jsonObj = $value ? json_decode($value, true) : [];
        if(count($jsonObj) > 0) {
            $this->attributes['available'] = true;
            if($jsonObj['type'] == 'amount') {
                return $jsonObj['amount'] . ' tickets available';
            } else {
                $date_time = \Carbon\Carbon::parse($jsonObj['date']);
                return 'Available until ' . $date_time->format("F ") . $date_time->day . ", ". $date_time->year;
            }
        } else {
            return null;
        }
    }

    public function getDescriptionAttribute()
    {
        if($this->special_validity != null) {
            return $this->special_validity;
        }
        return null;
    }

    public function getAvailableAttribute()
    {
        $jsonObj = $this->attributes['special_validity'] ? json_decode($this->attributes['special_validity'], true) : [];
        if(count($jsonObj) > 0) {
            $this->attributes['available'] = true;
            if($jsonObj['type'] == 'amount') {
                $count_registration = $this->registrations()->count();
                return (int)$jsonObj['amount'] - $count_registration > 0;
            } else {
                $time = \Carbon\Carbon::parse($jsonObj['date'])->timestamp;
                $now = now()->timestamp;
                return $time - $now >= 0;
            }
        } else {
            return true;
        }
    }


    public function getCostAttribute($value)
    {
        if($value == null) return 0;
        return (float)$value;
    }

    public function registrations()
    {
        return $this->hasMany(Registration::class, 'ticket_id');
    }

    public function campaign()
    {
        return $this->belongsTo(Campaign::class);
    }
}

14_module_d/source/app/Http/Controllers/Api/CampaignController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Campaign;
use App\Models\CampaignTicket;
use App\Models\Organizer;
use App\Models\Citizen;
use App\Models\Registration;
use App\Models\Session;
use App\Models\SessionRegistration;

class CampaignController extends Controller
{
    public function listCampaign()
    {
        return response()->json([
            "campaigns" => Campaign::with('organizer')->select('id', 'name', 'slug', 'organizer_id', 'date')->orderBy('date')->get()
        ]);
    }

    public function campaignDetail($organizer_slug, $campaign_slug)
    {
        $organizer = Organizer::where('slug', $organizer_slug)->first();
        if($organizer) {
            $campaign = Campaign::with('areas', 'tickets', 'areas.places', 'areas.places.sessions')->where('slug', $campaign_slug)->where('organizer_id', $organizer->id)->first();
            if($campaign) {
                return response()->json($campaign);
            }
            return response()->json(["message" => "Campaign not found"], 404);
        }
        return response()->json(["message" => "Organizer not found"], 404);
    }

    public function registration(Request $request)
    {
        $token = $request->token;
        if(!$token) return response()->json(["message" => "User not logged in"], 401);
        $citizen = Citizen::where('login_token', $token)->first();
        if(!$citizen) return response()->json(["message" => "User not logged in"], 401);
        $ticket = CampaignTicket::find($request->ticket_id);
        if(! is_array($request->session_ids)) {
            $session_ids = json_decode($request->session_ids, true);
        } else {
            $session_ids = $request->session_ids;
        }
        if(!$ticket) return response()->json(["message" => "Ticket not found"], 404);
        $sessions = Session::whereIn('id', $session_ids)->get();
        if(count($sessions) != count($session_ids)) return response()->json(["message" => "Sessions not found"], 404);
        $registration = Registration::where('ticket_id', $request->ticket_id)->where('citizen_id', $citizen->id)->count();
        if($registration > 0) return response()->json(["message" => "User already registered"], 401);
        if($ticket->available === false)  return response()->json(["message" => "Ticket is no longer available"], 401);
        $registration = new Registration;
        $registration->citizen_id = $citizen->id;
        $registration->ticket_id = $ticket->id;
        $registration->registration_time = now();
        $registration->save();
        foreach ($sessions as $session) {
            $session_registration = new SessionRegistration;
            $session_registration->registration_id = $registration->id;
            $session_registration->session_id = $session->id;
            $session_registration->save();
        }
        return response()->json(["message" => "Registration successful"], 200);
    }

    public function listRegistrations(Request $request)
    {
        $token = $request->token;
        if(!$token) return response()->json(["message" => "User not logged in"], 401);
        $citizen = Citizen::where('login_token', $token)->first();
        if(!$citizen) return response()->json(["message" => "User not logged in"], 401);
        $registrations = Registration::where('citizen_id', $citizen->id)->get();
        $results = [];
        foreach ($registrations as $registration) {
            $result = [
                "campaign" => Campaign::with('organizer')->select('id', 'name', 'slug', 'organizer_id', 'date')->where('id', $registration->ticket->campaign->id)->first(),
                "session_ids" => SessionRegistration::where('registration_id', $registration->id)->pluck('session_id')
            ];
            $results[] = $result;
        }
        return response()->json(["registrations" => $results], 200);
    }
}

14_module_d/source/app/Http/Controllers/Backend/CampaignController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Requests\CampaignCreateRequest;
use App\Http\Requests\CampaignEditRequest;
use App\Http\Controllers\Controller;
use App\Models\Campaign;
use Auth;

class CampaignController extends Controller
{
    public function managers()
    {
        return view('campaigns.index');
    }

    public function createForm()
    {
        return view('campaigns.create');
    }

    public function actionCreate(CampaignCreateRequest $request)
    {
        $campaign = new Campaign;
        $campaign->fill($request->only($campaign->fillable));
        $campaign->organizer_id = Auth::user()->id;
        if($campaign->save()) {
            return redirect()->route('campaign.detail', ['id' => $campaign->id, 'slug' => $campaign->slug])->with('suss', 'Campaign successfully created');
        }
        return redirect()->back()->with('err', 'Cant not create object');
    }

    public function detailCampaign($id, $slug)
    {
        $campaign = Campaign::with('tickets')->where('id', $id)->where('slug', $slug)->where('organizer_id', Auth::user()->id)->firstOrFail();
        return view('campaigns.detail', compact('campaign', $campaign));
    }

    public function editCampaign($id, $slug)
    {
        $campaign = Campaign::where('id', $id)->where('slug', $slug)->where('organizer_id', Auth::user()->id)->firstOrFail();
        return view('campaigns.edit', compact('campaign', $campaign));
    }

    public function actionEdit($id, $slug, CampaignEditRequest $request)
    {
        $campaign = Campaign::where('id', $id)->where('slug', $slug)->where('organizer_id', Auth::user()->id)->firstOrFail();
        $campaign->fill($request->only($campaign->fillable));
        if($campaign->save()) {
            return redirect()->route('campaign.detail', ['id' => $campaign->id, 'slug' => $campaign->slug])->with('suss', 'Campaign successfully updated');
        }
        return redirect()->back()->with('err', 'Cant not update object');
    }

    public function reportChart($id, $slug)
    {
        $campaign = Campaign::where('id', $id)->where('slug', $slug)->where('organizer_id', Auth::user()->id)->firstOrFail();
        $labels = [];
        $capacitys = [];
        $total_capacity = [];
        $color_capacitys = [];
        foreach ($campaign->places as $place) {
            $labels[] = $place->name;
            $capacitys[] = $place->capacity;
            $total_capacity[] = $place->session_registrations()->count();
            $color_capacitys[] = "#a1cbf5";
            if($place->capacity < $place->session_registrations()->count()) {
                $color_total_capacity[] = "#f1a8a2";
            } else {
                $color_total_capacity[] = "#cbdfac";
            }
        }
        return view('reports.index', compact('campaign', 'labels', 'capacitys', 'color_capacitys', 'total_capacity', 'color_total_capacity'));
    }
}

14_module_d/source/resources/views/campaigns/create.blade.php
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>CVC Backend</title>

    <base href="{{ asset('/') }}">
    <!-- Bootstrap core CSS -->
    <link href="assets/css/bootstrap.css" rel="stylesheet">
    <!-- Custom styles -->
    <link href="assets/css/custom.css" rel="stylesheet">
</head>

<body>
<nav class="navbar navbar-dark fixed-top bg-dark flex-md-nowrap p-0 shadow">
    <a class="navbar-brand col-sm-3 col-md-2 mr-0" href="{{ route('campaign.manager')}}">CVC Backend</a>
    <span class="navbar-organizer w-100">{{ Auth::user()->name }}</span>
    <ul class="navbar-nav px-3">
        <li class="nav-item text-nowrap">
            <a class="nav-link" id="logout" href="{{ route('logout') }}">Sign out</a>
        </li>
    </ul>
</nav>

<div class="container-fluid">
    <div class="row">
        <nav class="col-md-2 d-none d-md-block bg-light sidebar">
            <div class="sidebar-sticky">
                <ul class="nav flex-column">
                    <li class="nav-item"><a class="nav-link active" href="{{ route('campaign.manager') }}">Manage Campaigns</a></li>
                </ul>
            </div>
        </nav>

        <main role="main" class="col-md-9 ml-sm-auto col-lg-10 px-4">
            <div
                class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center pt-3 pb-2 mb-3 border-bottom">
                <h1 class="h2">Manage Campaigns</h1>
            </div>

            <div class="mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h2 class="h4">Create new campaign</h2>
                </div>
            </div>

            <form class="needs-validation" novalidate action="{{ route('campaign.create') }}" method="POST">
                @include('components.showNoti')
                @csrf
                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'name'])
                        <label for="inputName">Name</label>
                        <input type="text" class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" id="inputName" name="name" placeholder="" value="{{ old('name') }}">
                        @endcomponent
                    </div>
                </div>

                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'slug'])
                        <label for="inputSlug">Slug</label>
                        <input type="text" class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" id="inputSlug" name="slug" placeholder="" value="{{ old('slug') }}">
                        @endcomponent
                    </div>
                </div>

                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'date'])
                        <label for="inputDate">Date</label>
                        <input type="text"
                               class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}"
                               id="inputDate"
                               name="date"
                               placeholder="yyyy-mm-dd"
                               value="{{ old('date') }}">
                        @endcomponent
                    </div>
                </div>

                <hr class="mb-4">
                <button class="btn btn-primary" type="submit">Save campaign</button>
                <a href="{{ route('campaign.manager') }}" class="btn btn-link">Cancel</a>
            </form>

        </main>
    </div>
</div>

</body>
</html>

14_module_d/source/resources/views/campaigns/detail.blade.php
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>CVC Backend</title>

    <base href="{{ asset('/') }}">
    <!-- Bootstrap core CSS -->
    <link href="assets/css/bootstrap.css" rel="stylesheet">
    <!-- Custom styles -->
    <link href="assets/css/custom.css" rel="stylesheet">
</head>

<body>
<nav class="navbar navbar-dark fixed-top bg-dark flex-md-nowrap p-0 shadow">
    <a class="navbar-brand col-sm-3 col-md-2 mr-0" href="{{ route('campaign.manager')}}">Event Platform</a>
    <span class="navbar-organizer w-100">{{ Auth::user()->name }}</span>
    <ul class="navbar-nav px-3">
        <li class="nav-item text-nowrap">
            <a class="nav-link" id="logout" href="{{ route('logout') }}">Sign out</a>
        </li>
    </ul>
</nav>

<div class="container-fluid">
    <div class="row">
        <nav class="col-md-2 d-none d-md-block bg-light sidebar">
            <div class="sidebar-sticky">
                <ul class="nav flex-column">
                    <li class="nav-item"><a class="nav-link" href="{{ route('campaign.manager')}}">Manage Campaigns</a></li>
                </ul>

                <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                    <span>{{ $campaign->name }}</span>
                </h6>
                <ul class="nav flex-column">
                    <li class="nav-item"><a class="nav-link active" href="{{ route('campaign.detail', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}">Overview</a></li>
                </ul>

                <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                    <span>Reports</span>
                </h6>
                <ul class="nav flex-column mb-2">
                    <li class="nav-item"><a class="nav-link" href="{{ route('campaign.report', [$campaign->id, $campaign->slug]) }}">Palce capacity</a></li>
                </ul>
            </div>
        </nav>

        <main role="main" class="col-md-9 ml-sm-auto col-lg-10 px-4">
            <div class="border-bottom mb-3 pt-3 pb-2 event-title">
                @include('components.showNoti')
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h1 class="h2">{{ $campaign->name }}</h1>
                    <div class="btn-toolbar mb-2 mb-md-0">
                        <div class="btn-group mr-2">
                            <a href="{{ route('campaign.edit', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}" class="btn btn-sm btn-outline-secondary">Edit campaign</a>
                        </div>
                    </div>
                </div>
                <span class="h6">{{ $campaign->date }}</span>
            </div>

            <!-- Tickets -->
            <div id="tickets" class="mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h2 class="h4">Tickets</h2>
                    <div class="btn-toolbar mb-2 mb-md-0">
                        <div class="btn-group mr-2">
                            <a href="{{ route('campaign.create_ticket', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}" class="btn btn-sm btn-outline-secondary">
                                Create new ticket
                            </a>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row tickets">
                @foreach($campaign->tickets as $ticket)
                <div class="col-md-4">
                    <div class="card mb-4 shadow-sm">
                        <div class="card-body">
                            <h5 class="card-title">{{ $ticket->name }}</h5>
                            <p class="card-text">{{ $ticket->cost }} .-</p>
                            <p class="card-text">{!! $ticket->special_validity == null ? '&nbsp;' : $ticket->special_validity !!}</p>
                        </div>
                    </div>
                </div>
                @endforeach
            </div>

            <!-- Sessions -->
            <div id="sessions" class="mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h2 class="h4">Sessions</h2>
                    <div class="btn-toolbar mb-2 mb-md-0">
                        <div class="btn-group mr-2">
                            <a href="{{ route('campaign.create_session', [$campaign->id, $campaign->slug]) }}" class="btn btn-sm btn-outline-secondary">
                                Create new session
                            </a>
                        </div>
                    </div>
                </div>
            </div>

            <div class="table-responsive sessions">
                <table class="table table-striped">
                    <thead>
                    <tr>
                        <th>Time</th>
                        <th>Type</th>
                        <th class="w-100">Title</th>
                        <th>Participant</th>
                        <th>Area</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($campaign->sessions() as $session)
                    <tr>
                        <td class="text-nowrap">{{ $session->start->format('H:i') }} - {{ $session->end->format('H:i') }}</td>
                        <td>{{ ucfirst($session->type) }}</td>
                        <td><a href="{{ route('campaign.update_session', [$campaign->id, $campaign->slug, $session->id]) }}">{{ $session->title }}</a></td>
                        <td class="text-nowrap">{{ $session->vaccinator }}</td>
                        <td class="text-nowrap">{{ $session->place->area->name }} / {{ $session->place->name }}</td>
                    </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>

            <!-- Areas -->
            <div id="channels" class="mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h2 class="h4">Areas</h2>
                    <div class="btn-toolbar mb-2 mb-md-0">
                        <div class="btn-group mr-2">
                            <a href="{{ route('campaign.create_area', [$campaign->id, $campaign->slug]) }}" class="btn btn-sm btn-outline-secondary">
                                Create new area
                            </a>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row channels">
                @foreach($campaign->areas as $area)
                <div class="col-md-4">
                    <div class="card mb-4 shadow-sm">
                        <div class="card-body">
                            <h5 class="card-title">{{ $area->name }}</h5>
                            <p class="card-text">{{ $area->sessions()->count() }} sessions, {{ $area->places()->count() }} palce</p>
                        </div>
                    </div>
                </div>
                @endforeach
            </div>

            <!-- Palces -->
            <div id="rooms" class="mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h2 class="h4">Places</h2>
                    <div class="btn-toolbar mb-2 mb-md-0">
                        <div class="btn-group mr-2">
                            <a href="{{ route('campaign.create_place', [$campaign->id, $campaign->slug]) }}" class="btn btn-sm btn-outline-secondary">
                                Create new place
                            </a>
                        </div>
                    </div>
                </div>
            </div>

            <div class="table-responsive rooms">
                <table class="table table-striped">
                    <thead>
                    <tr>
                        <th>Name</th>
                        <th>Capacity</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($campaign->places as $place)
                    <tr>
                        <td>{{ $place->name }}</td>
                        <td>{{ number_format($place->capacity, 0, '.', ',') }}</td>
                    </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>

        </main>
    </div>
</div>

</body>
</html>

14_module_d/source/resources/views/campaigns/edit.blade.php
<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>CVC Backend</title>

    <base href="../../">
    <!-- Bootstrap core CSS -->
    <link href="assets/css/bootstrap.css" rel="stylesheet">
    <!-- Custom styles -->
    <link href="assets/css/custom.css" rel="stylesheet">
</head>

<body>
<nav class="navbar navbar-dark fixed-top bg-dark flex-md-nowrap p-0 shadow">
    <a class="navbar-brand col-sm-3 col-md-2 mr-0" href="{{ route('campaign.manager')}}">CVC Backend</a>
    <span class="navbar-organizer w-100">{{ Auth::user()->name }}</span>
    <ul class="navbar-nav px-3">
        <li class="nav-item text-nowrap">
            <a class="nav-link" id="logout" href="{{ route('logout') }}">Sign out</a>
        </li>
    </ul>
</nav>

<div class="container-fluid">
    <div class="row">
        <nav class="col-md-2 d-none d-md-block bg-light sidebar">
            <div class="sidebar-sticky">
                <ul class="nav flex-column">
                    <li class="nav-item"><a class="nav-link" href="{{ route('campaign.manager')}}">Manage Campaigns</a></li>
                </ul>

                <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                    <span>{{ $campaign->name }}</span>
                </h6>
                <ul class="nav flex-column">
                    <li class="nav-item"><a class="nav-link active" href="{{ route('campaign.detail', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}">Overview</a></li>
                </ul>

                <h6 class="sidebar-heading d-flex justify-content-between align-items-center px-3 mt-4 mb-1 text-muted">
                    <span>Reports</span>
                </h6>
                <ul class="nav flex-column mb-2">
                    <li class="nav-item"><a class="nav-link" href="{{ route('campaign.report', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}">Place capacity</a></li>
                </ul>
            </div>
        </nav>

        <main role="main" class="col-md-9 ml-sm-auto col-lg-10 px-4">
            <div class="border-bottom mb-3 pt-3 pb-2">
                <div class="d-flex justify-content-between flex-wrap flex-md-nowrap align-items-center">
                    <h1 class="h2">{{ $campaign->name }}</h1>
                </div>
            </div>

            <form class="needs-validation" novalidate action="{{ route('campaign.edit', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}" method="POST">
                @include('components.showNoti')
                @csrf
                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'name'])
                        <label for="inputName">Name</label>
                        <input type="text" class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" id="inputName" name="name" placeholder="" value="{{ old('name') ? old('name') : $campaign->name }}">
                        @endcomponent
                    </div>
                </div>

                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'slug'])
                        <label for="inputSlug">Slug</label>
                        <input type="text" class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}" id="inputSlug" name="slug" placeholder="" value="{{ old('slug') ? old('slug') : $campaign->slug }}">
                        @endcomponent
                    </div>
                </div>

                <div class="row">
                    <div class="col-12 col-lg-4 mb-3">
                        @component('components.input', ['errors' => $errors, 'label' => 'date'])
                        <label for="inputDate">Date</label>
                        <input type="text"
                               class="form-control {{ $errors->has('name') ? 'is-invalid' : '' }}"
                               id="inputDate"
                               name="date"
                               placeholder="yyyy-mm-dd"
                               value="{{ old('date') ? old('date') : $campaign->date }}">
                        @endcomponent
                    </div>
                </div>

                <hr class="mb-4">
                <button class="btn btn-primary" type="submit">Save</button>
                <a href="{{ route('campaign.detail', ['id' => $campaign->id, 'slug' => $campaign->slug]) }}" class="btn btn-link">Cancel</a>
            </form>

        </main>
    </div>
</div>

</body>
</html>